#include <stdio.h>
#include <math.h>
#include <time.h>
typedef unsigned char byte;
byte bits[8]={1,2,4,8,16,32,64,128};
/*--------------------------------------------------------------------------*/
void bitprint(z)
short z;
{
int mask={0xffff},yq;
int i;
yq=z & mask;
for (i=0;i<16;i++) {printf("%1d",yq%2); yq=yq/2; }
printf(" ");
return;
}	/* end of bitprint */
/*--------------------------------------------------------------------------*/
int anacrunch(x,array,r9,nx,ny)
/* compress 16 bit array into x (a byte array) using ny blocks each of size
nx, bit slice size r9, returns # of bytes in x */
	unsigned char x[];
	int nx,ny,r9;
	short array[];
{
clock_t		t1,t2,t3;
short iq;
unsigned nb,ixa,ixb;
unsigned register i,j,r1,in;
int r0,r2,r3,r4,r5,r6,r7,r8,mask,fac;
int i2,k,ix,iy;
unsigned char xq;
union { int i; short w; unsigned char b[4]; } y;
/* begin execution */
t1=clock();
/*printf("nx,ny = %d, %d \n",nx,ny);*/
mask=1; for (i=0;i<r9;i++) mask=2*mask;
fac=mask;	mask=mask-1; /* no inline expon. in C */
/* determine the # of bytes to transfer to 32 bit int for fixed portion */
if (r9 == 0) nb=0; else { if (r9 < 2 ) nb=1;
	else { if (r9 < 10) nb=2; else nb=3;	}};
y.i=0;
i=0;	r1=0;	in=0;
for (iy=0;iy<ny;iy++) {			/* start of iy (outer) loop */
/* load the first value, reverse bytes (VAX style)*/
y.w=array[in]	;x[i]=y.b[1]	;x[i+1]=y.b[0];
/* in=in+1;*/
r1=r1+16;
r2=0;
ixa=1+iy*nx;	ixb=(iy+1)*nx;
/*for (ix=1; ix<nx; ix++)	{	*/	/* start of ix (inner) loop */
for (in=ixa; in<ixb; in++)	{		/* start of ix (inner) loop */
/* first the fixed slice portion */
y.i=array[in]-array[in-1];
r3=(y.i>>r9);
i=r1>>3;
j=r1%8;
/* now load nb bytes into x */
/*low order byte of y.i is first in stream */
if (j == 0) {y.i=(y.i & mask); x[i]=y.b[3];}
	else { y.i=(y.i & mask)<<j; x[i]=x[i] | y.b[3];}
/*if (nb>1) { x[i+1]=y.b[2]; if (nb>2) x[i+2]=y.b[1]; } */
x[i+1]=y.b[2];
r1=r1+r9;	/* bump r1 pass the fixed part */
i=r1>>3;		j=r1%8;
/* note that r3 is the # of bits required minus 1 */
if (r3==0) { if (j ==0 ) {x[i]=bits[j];} else {x[i]=x[i]|bits[j];}
r1+=1;}	else	{
r3=2*r3;	if (r3<0) r3 = -r3-1;
if (r3<31)  {
r0=j+r3;	/* this is the bit that needs setting offset from x[i] */
if (r0 < 8) { if (j == 0) x[i]=bits[r0]; else x[i]=x[i]|bits[r0];}
else {if (j == 0) x[i]=0;  j=r0%8; if (r0 < 16) x[i+1]=bits[j];
else { i2=i+r0/8; for (k=i+1;k<i2;k++) x[k]=0;	x[i2]=bits[j]; }
}
r1+=1+r3;
} else {	/* big one exception, should be rare */
/* does not need to be efficient, used rarely */
printf("big one \n");
if (j == 0) x[i]=0;	/* gotta zero the virgins */
r0=j+31;	j=r0%8;		i2=i+r0/8;
for (k=i+1;k<i2;k++) x[k]=0;	x[i2]=bits[j];
/* recompute the difference and load 17 bits (always 3 bytes) */
r1=r1+32;
i=r1/8;
j=r1%8;
if (j == 0) x[i]=0;	/* gotta zero the virgins */
y.i=((array[in]-array[in-1])& 0x1ffff) << j;
x[i]=x[i] | y.b[3]; x[i+1]=y.b[2];	x[i+2]=y.b[1];
r1=r1+17;	} /* end of big one exception */
		}	/* end of (r3==0) conditional */
/*in=in+1; */			}	/* end of ix loop */
/* some checks here */
/* bump to next byte boundary */
i=(r1+7)/8;	r1=8*i;			}	/* end of iy loop */
/* some statistics */
/*t2=clock();	printf("crunch time = %8.3f\n",(t2-t1)/1.e6);*/
return	i;	/*return # of bytes used */
}	/* end of routine */
/*----------------------------------------------------------------------------*/
