	/* works on ANA compressed files */
	/* 3/20/91 test code, use Vax files (reversed bytes wrt SGI) */
#include <stdio.h>
typedef unsigned char byte;
/*----------------------------------------------------------------------------*/
void anadecrunch8(x,array,r9,nx,ny)
	/* decompress a bit stream in x; result is n I*1 elements, put in array;
	 bit slice size r9 */
	byte x[];
	int nx,ny,r9;
	byte array[];
				/* byte version, modified from I*2 version
				r. shine 6/5/91 */
{
/*clock_t t1,t2,t3;*/
byte iq;
int r0,r1,r2,r3,r4,r5,r6,r7,r8,nb,mask;
int j,in,i,k,ix,iy;
byte xq;
union { int i; short w; unsigned char b[4]; } y;
/* begin execution */
/*t1=clock();*/
mask=1; for (i=0;i<r9;i++) mask=2*mask;	mask=mask-1; /* no inline expon. in C */
/*printf("slice width = %d\n",r9);*/
/*printf ("mask = %x, %d\n",mask,mask);*/
/* determine the # of bytes to transfer to 32 bit int for fixed portion */
if (r9 == 0) nb=0; else { if (r9 < 2 ) nb=1;
	else { if (r9 < 10) nb=2; else nb=3;	}};
y.i=0;
i=0;	r1=0;	in=0;
for (iy=0;iy<ny;iy++) {			/* start of iy (outer) loop */
/* get the first value */
iq=x[i];	array[in++]=iq;
r1=r1+8;
r2=0;
for (ix=1; ix<nx; ix++)	{
/* first the fixed slice portion */
i=r1/8;		j=r1%8;
/* y.b[3]=x[i]; */
y.b[0]=x[i];
/* test effect on timing */
/* if (nb>1) { y.b[2]=x[i+1]; if (nb>2) y.b[1]=x[i+2]; } */
if (nb>1) { y.b[1]=x[i+1]; if (nb>2) y.b[2]=x[i+2]; }
/* shift and mask out the bit slice */
r2=(y.i>>j) & mask;
/*printf("r2 = %x, %d\n",r2,r2);*/
/* the variable bit portion, find the first set bit */
r1=r1+r9;	/* bump r1 pass the fixed part */
i=r1/8;		j=r1%8;
if ((xq=x[i]>>j) != 0) {
/* caught it on first byte, find the bit */
if ((xq&1) != 0) r0=1; else {
if ((xq&2) != 0) r0=2; else {
if ((xq&4) != 0) r0=3; else {
if ((xq&8) != 0) r0=4; else {
if ((xq&16) != 0) r0=5; else {
if ((xq&32) != 0) r0=6; else {
if ((xq&64) != 0) r0=7; else {
if ((xq&128) != 0) r0=8; }}}}}}}}	else {
/* not in first byte (or part of one) checked, carry on, first count bits in
	that first byte */
r0=8-j;
/* check up to 4 more bytes, if not found than an error */
for (k=i+1;k<i+5;k++) { if ( (xq=x[k]) != 0 ) {
/* caught it here, find the bit and then jump from loop */
if ((xq&1) != 0) r0+=1; else {
if ((xq&2) != 0) r0+=2; else {
if ((xq&4) != 0) r0+=3; else {
if ((xq&8) != 0) r0+=4; else {
if ((xq&16) != 0) r0+=5; else {
if ((xq&32) != 0) r0+=6; else {
if ((xq&64) != 0) r0+=7; else {
if ((xq&128) != 0) r0+=8; }}}}}}} break; } else { r0=r0+8; 
/* add 8 bits for each all zero byte */
if (r0 > 32) { printf("DECRUNCH -- bad bit sequence, cannot continue");
	return; }	}	}	}
r1=r1+r0;	/* update pointer */
/* r0 even or odd determines sign of difference */
/*printf("r0 = %d\n",r0);*/
if ((r0&1) != 0) { 
/* positive case */
r0=(r0/2)<<r9;	iq=iq+r2;	iq=iq+r0;	array[in]=iq;
/*printf("plus case, r2= %x, r0= %x ",r2,r0);*/
/*printf(" increment = %d\n",r2+r0);*/
 } else
{ if (r0 == 32) { 
/* a long one, yank out the next 9 bits and use as difference */
i=r1/8;		j=r1%8;
/* y.b[3]=x[i]; */
y.b[0]=x[i];
/* y.b[2]=x[i+1]; */
y.b[1]=x[i+1];
/* shift and mask out the 9 bit slice */
r2=(y.i>>j) & 0x1ff;
r1=r1+9;
/*printf("long case, r2= %x\n",r2);*/
/* if the top bit was set, do a sign extend, note that 32 bit arithmetic used*/
if ( (r2& 0x100) != 0 ) r2=r2 | 0xffffff00;
r4=array[in-1]; r4=r4+r2; array[in]=r4; iq=r4;
/*printf("long, continued, final r2 = %d %x\n",r2,r2);*/
} else {
/* minus case (normal) */
r0=(-r0/2)<<r9;	iq=iq+r2;	iq=iq+r0;	array[in]=iq;
/*printf("minus case, r2= %x, r0= %x ",r2,r0);*/
/*printf(" increment = %d\n",r2+r0);*/	} }
in=in+1;				}	/* end of ix loop */
i=(r1+7)/8;	r1=8*i;			}	/* end of iy loop */
/*t2=clock();	printf("decrunch time = %8.3f\n",(t2-t1)/1.e6);*/
}	/* end of routine */
